--[[-----------------------------------------------------------------------------
Horiz Line Widget
-------------------------------------------------------------------------------]]
local Healcsi      = Healcsi
local Gui          = Healcsi.Gui
local TopParent    = Healcsi.UIParent
local HiddenParent = Healcsi.HiddenParent

local Type, Version = "Healcsi-HorizLine", 1
local AceGUI = LibStub and LibStub("AceGUI-3.0", true)
if not AceGUI or (AceGUI:GetWidgetVersion(Type) or 0) >= Version then return end

-- Lua APIs
local max, select, pairs = math.max, select, pairs

-- WoW APIs
local CreateFrame = CreateFrame

-- Global vars/functions that we don't upvalue since they might get hooked, or upgraded
-- List them here for Mikk's FindGlobals script
-- GLOBALS: GameFontHighlightSmall

--[[-----------------------------------------------------------------------------
Support functions
-------------------------------------------------------------------------------]]


--[[-----------------------------------------------------------------------------
Methods
-------------------------------------------------------------------------------]]
local methods = {
	["OnAcquire"] = function(self)
		
		self:SetHeight(8)
		self:SetFullWidth(true)

		--self.line:SetTexture(Healcsi:GetMedia("statusbar", "Solid"))
		self.line:SetTexture([[Interface\Addons\Healcsi\Media\UI\line]])
		self.line:SetVertexColor(Healcsi:GetColor("DarkBlue", 0.8))

	end,



	-- ["OnRelease"] = nil,

}

--[[-----------------------------------------------------------------------------
Constructor
-------------------------------------------------------------------------------]]
local function Constructor()
	local frame = CreateFrame("Frame", nil, TopParent)
	frame:Hide()

	local line = frame:CreateTexture(nil, "ARTWORK")
	line:SetPoint("LEFT", frame, "LEFT", 15, 0)
	line:SetPoint("RIGHT", frame, "RIGHT", -15, 0)
	line:SetHeight(2)

	-- create widget
	local widget = {
		line = line,
		frame = frame,
		type  = Type
	}
	for method, func in pairs(methods) do
		widget[method] = func
	end

	return AceGUI:RegisterAsWidget(widget)
end

AceGUI:RegisterWidgetType(Type, Constructor, Version)
