
local Healcsi      = Healcsi
local Console      = Healcsi.Console
local Media        = Healcsi.Media
local Gui          = Healcsi.Gui
local L            = Healcsi.Locale
local Modules      = Healcsi.Modules
local ToolBox      = Healcsi.Modules.ToolBox
local UnitButtons  = Healcsi.Modules.UnitButtons
local UnitFrames   = Healcsi.Modules.UnitFrames
local Editor       = Healcsi.Editor


Healcsi:RegisterEventCallback("UpdateEditorLayout", function()
	ToolBox:RefreshScrollBar()
end)

Healcsi:RegisterEventCallback("GlobalConfigRefresh", function()
	ToolBox.parentFrame:ReleaseChildren()
	ToolBox:CreateToolBoxEditorView(ToolBox.parentFrame)
end)

function ToolBox:RefreshScrollBar()
	--local pos = self.e.scrollbar:GetValue()

	--self.scrollFrame:DoLayout()
	--self.scrollFrame:FixScroll() -- avoid jumpy scrollbar

	--self.scrollFrame.scrollbar:SetValue(pos) -- set position
	--self.scrollFrame:SetScroll(pos) -- just to be sure. don't think this is needed btw...
end


function ToolBox:CreateToolBoxEditorView(frame)

	local db = Healcsi.db.profile.ToolBox
	local holder = Editor:CreateGroup(frame, true, nil, {10, 0, 10, 10}, {0, 5, 0, 5}, "BlueSelected", 0.3)

	Editor:CreateHeaderlabel(holder, L["ToolBox"])

	local broadcast = "ToolBoxConfigChanged"

	local line0 = Editor:CreateInlineGroup(holder, true, nil, {10, 0, 10, 10})
	Editor:CreateCheckBox(line0, false, 300, L["showToolboxShow"], db, "show", "ToolBoxShowChanged", broadcast)

	local anchorList = {
		["CENTER"]   = "Center",
		["LEFT"]     = "Left",
		["TOP"]      = "Top",
		["RIGHT"]    = "Right",
		["BOTTOM"]   = "Bottom",

		["TOPLEFT"]  = "Top left",
		["TOPRIGHT"]  = "Top right",
		["BOTTOMLEFT"]  = "Bottom left",
		["BOTTOMRIGHT"]  = "Bottom right"
	}
	local line1 = Editor:CreateInlineGroup(holder, true, nil, {10, 0, 10, 10})
	Editor:CreateDropDown(line1, false, 300, L["Anchor"], anchorList, db, "anchor", "ToolBoxAnchor", broadcast)

	local line2 = Editor:CreateInlineGroup(holder, true, nil, {10, 0, 10, 10})
	Editor:CreateSlider(line2, false, 300, L["OffsetX"], -500, 500, 1, false, db.offset, "x", "ToolBoxSOffsetX", broadcast)
	Editor:CreateSlider(line2, false, 300, L["OffsetY"], -500, 500, 1, false, db.offset, "y", "ToolBoxSOffsetY", broadcast)

end

function ToolBox:CreateEditor()

	local scrollFrame = Gui:Create("Healcsi-ScrollFrame")
	scrollFrame:SetLayout("Flow")
	scrollFrame:SetFullWidth(true)
	scrollFrame:SetFullHeight(true)
	self.scrollFrame = scrollFrame

	local parentFrame = Gui:Create("SimpleGroup")
	parentFrame:SetLayout("Flow")
	parentFrame:SetFullWidth(true)
	parentFrame:SetFullHeight(true)
	self.parentFrame = parentFrame

	self:CreateToolBoxEditorView(parentFrame)

	scrollFrame:AddChild(parentFrame)
	return scrollFrame
end