local Healcsi    = Healcsi
local Console    = Healcsi.Console
local Media      = Healcsi.Media
local Gui        = Healcsi.Gui
local L          = Healcsi.Locale
local Modules    = Healcsi.Modules

Modules.UnitButtons = {
	name = "Unit Buttons",
	id = 1,
	key = "UnitButtons",
	initDone = false,

	defaults = {
		selectedTab = "size",
		icons = {
			privilege = {
				leader = {
					show = true,
					anchor = "BOTTOM",
					offset = {
						x = 0,
						y = -1
					},
					size = 12,
					alpha = 1,
					zoom = "NaN" -- must be here for ponies sake, the editor would go crazy otherwise.
				},
				loot = {
					show = true,
					anchor = "BOTTOM",
					offset = {
						x = 12,
						y = -1
					},
					size = 12,
					alpha = 1,
					zoom = "NaN" -- must be here for ponies sake, the editor would go crazy otherwise.
				},
				mainTank = {
					show = true,
					size = 13,
					anchor = "BOTTOM",
					offset = {
						x = -14,
						y = -1
					},
					alpha = 1,
					zoom = "NaN" -- must be here for ponies sake, the editor would go crazy otherwise.
				},
				mainAssist = {
					show = true,
					anchor = "BOTTOM",
					offset = {
						x = 0,
						y = -1
					},
					size = 12,
					alpha = 1,
					zoom = "NaN" -- must be here for ponies sake, the editor would go crazy otherwise.
				},
				assist = {
					show = true,
					anchor = "BOTTOM",
					offset = {
						x = 0,
						y = -1
					},
					size = 12,
					alpha = 1,
					zoom = "NaN" -- must be here for ponies sake, the editor would go crazy otherwise.
				}
			},
			role = {
				show = true,
				anchor = "TOPLEFT",
				offset = {
					x = -3,
					y = 2
				},
				size = 14,
				alpha = 1,
				zoom = 0.08
			},
			raidTarget = {
				show = true,
				anchor = "TOP",
				offset = {
					x = 0,
					y = 0
				},
				size = 14,
				alpha = 1,
				zoom = "NaN" -- must be here for ponies sake, the editor would go crazy otherwise.
			},
			flag = {
				anchor = "CENTER",
				offset = {
					x = 0,
					y = 0
				},
				size = 26,
				alpha = 0.6,
				zoom = 0.02
			},
			resurrect = {
				anchor = "CENTER",
				offset = {
					x = 0,
					y = 0
				},
				size = 26,
				alpha = 0.6,
				zoom = 0.08
			},
			readyCheck = {
				anchor = "CENTER",
				offset = {
					x = 0,
					y = 0
				},
				size = 26,
				alpha = 0.6,
				zoom = "NaN" -- must be here for ponies sake, the editor would go crazy otherwise.
			}
		},
		size = {
			spacing = 3,
			unitWidth = 110,
			unitHeight = 60,
			powerHeight = 6,
			petPowerHeight = 3,
			outrangeOpacity = 0.4
		},
		background = {
			file = "Solid",
			color = {r=40/255, g=40/255, b=40/255, a=175/255} --,
			--showBackground = true
		},
		health = {
			show = true, -- this MUST be true! or else ponies will die @@!!
			file = "BantoBar",
			color = {
				hostile = {
					fix = {r=240/255, g=5/255, b=5/255, a=250/255}
				},
				friendly = {
					fix = {r=5/255, g=240/255, b=5/255, a=250/255}
				},
				neutral = {
					fix = {r=240/255, g=240/255, b=5/255, a=250/255}
				},
				offline = {
					fix = {r=200/255, g=200/255, b=200/255, a=40/255}
				},
				dead = {
					fix = {r=238/255, g=196/255, b=151/255, a=250/255}
				},
				inVehicle = {
					color = {
						mode       = "fix", -- class, health, fix
						shadeMode  = "hsvShade", -- rgbShade, hsvShade
						alpha      = 1,
						rgb        = {r=0, g=0, b=0},
						hsv        = {h=0, s=0, v=-0.2},
						fix        = {r=250/255, g=190/255, b=108/255, a=200/255}
					}
				},
				pet = {
					color = {
						mode       = "class", -- class, health, fix
						shadeMode  = "hsvShade", -- rgbShade, hsvShade
						alpha      = 1,
						rgb        = {r=0, g=0, b=0},
						hsv        = {h=0, s=0.4, v=-0.2},
						fix        = {r=40/255, g=40/255, b=40/255, a=175/255}
					}
				},
				fix        = {r=40/255, g=40/255, b=40/255, a=175/255},
				mode       = "class", -- class, health, fix
				shadeMode  = "hsvShade", -- rgbShade, hsvShade
				alpha      = 1,
				rgb        = {r=0, g=0, b=0},
				hsv        = {h=0, s=0, v=-0.3}
			},
			underlay = {
				show = true,
				file = "Solid",
				color = {
					inVehicle = {
						color = {
							mode       = "fix", -- class, health, fix
							shadeMode  = "hsvShade", -- rgbShade, hsvShade
							alpha      = 1,
							rgb        = {r=0, g=0, b=0},
							hsv        = {h=0, s=0, v=-0.2},
							fix        = {r=230/255, g=55/255, b=45/255, a=200/255}
						}
					},
					pet = {
						color = {
							mode       = "class", -- class, health, fix
							shadeMode  = "hsvShade", -- rgbShade, hsvShade
							alpha      = 1,
							rgb        = {r=0, g=0, b=0},
							hsv        = {h=0, s=-0.1, v=0.2},
							fix        = {r=40/255, g=40/255, b=40/255, a=175/255}
						}
					},
					fix        = {r=40/255, g=40/255, b=40/255, a=175/255},
					mode       = "class", -- class, health, fix
					shadeMode  = "hsvShade", -- rgbShade, hsvShade
					alpha      = 0.9,
					rgb        = {r=0, g=0, b=0},
					hsv        = {h=0, s=0, v=0.4}
				}
			}
		},
		power = {
			file = "Solid",
			color = {
				mode      = "auto", -- fix, auto
				shadeMode = "hsvShade", -- rgbShade, hsvShade
				alpha     = 1,
				fix       = {r=48/255, g=42/255, b=230/255, a=255/255},
				rgb       = {r=0, g=0, b=0},
				hsv       = {h=0, s=0, v=-0.65}
			},
			underlay = {
				file = "Solid",
				color = {
					mode      = "auto", -- fix, auto
					shadeMode = "hsvShade", -- rgbShade, hsvShade
					alpha     = 1,
					fix       = {r=80/255, g=80/255, b=255/255, a=255/255},
					rgb       = {r=0, g=0, b=0},
					hsv       = {h=0, s=0, v=0.65}
				}
			}
		},
		tooltip = {
			show = "outOfCombat", -- always, outOfCombat, never
			position = "unitButton" -- default, unitButton
		},
		shield = {
			showAbsorbBar = true,
			file = "MitsuSaint-Xeon",
			color = {
				mode      = "class", -- class, health, fix
				shadeMode = "hsvShade", -- rgbShade, hsvShade
				alpha     = 0.75,
				fix       = {r=40/255, g=40/255, b=40/255, a=175/255},
				rgb       = {r=0, g=0, b=0},
				hsv       = {h=20, s=0.5, v=-0.1}
			},
			border = {
				left = {
					show = true,
					size = 3,
					file = "left-5",
					color = {
						mode      = "fix", -- fix, class, health
						shadeMode = "hsvShade", -- rgbShade, hsvShade
						alpha     = 0.9,
						fix       = {r=255/255, g=255/255, b=255/255, a=225/255},
						rgb       = {r=0, g=0, b=0},
						hsv       = {h=0, s=0.5, v=-0.5}
					}
				},
				right = {
					show = false,
					size = 3,
					file = "right-5",
					color = {
						mode = "fix", -- fix, class, health
						shadeMode = "hsvShade", -- rgbShade, hsvShade
						alpha = 0.9,
						fix = {r=25/255, g=25/255, b=25/255, a=225/255},
						rgb = {r=0, g=0, b=0},
						hsv = {h=0, s=0.5, v=-0.5}
					}
				},
				top = {
					show = false,
					size = 2,
					file = "top-5",
					color = {
						mode = "fix", -- fix, class, health
						shadeMode = "hsvShade", -- rgbShade, hsvShade
						alpha = 0.9,
						fix = {r=25/255, g=25/255, b=25/255, a=225/255},
						rgb = {r=0, g=0, b=0},
						hsv = {h=0, s=0.5, v=-0.5}
					}
				},
				bottom = {
					show = false,
					size = 2,
					file = "bottom-5",
					color = {
						mode = "fix", -- fix, class, health
						shadeMode = "hsvShade", -- rgbShade, hsvShade
						alpha = 0.9,
						fix = {r=25/255, g=25/255, b=25/255, a=225/255},
						rgb = {r=0, g=0, b=0},
						hsv = {h=0, s=0.5, v=-0.5}
					}
				}
			}
		},
		absorb = {
			file = "absorb-11",
			color = {
				mode = "fix", -- fix, class, health
				shadeMode = "hsvShade", -- rgbShade, hsvShade
				alpha = 0.9,
				fix = {r=255/255, g=177/255, b=80/255, a=255/255},
				rgb = {r=0, g=0, b=0},
				hsv = {h=0, s=-0.5, v=0.9}
			}
		},
		incHeal = {
			file = "Solid",
			color = {
				mode = "class", -- fix, class, health
				shadeMode = "hsvShade", -- rgbShade, hsvShade
				alpha = 0.9,
				fix = {r=255/255, g=177/255, b=80/255, a=255/255},
				rgb = {r=0, g=0, b=0},
				hsv = {h=0, s=0.3, v=0}
			},
			absorb = {
				file = "absorb-11",
				color = {
					mode = "fix", -- fix, class, health
					shadeMode = "hsvShade", -- rgbShade, hsvShade
					alpha = 0.9,
					fix = {r=63/255, g=200/255, b=26/255, a=255/255},
					rgb = {r=0, g=0, b=0},
					hsv = {h=0, s=-0.5, v=0.9}
				}
			}
		},
		nameText = {
			anchor = "CENTER",
			offset = {
				x = 0,
				y = 4
			},
			font = {
				file = "Friz Quadrata TT",
				size = 14,
				outline = false,
				shadow = {
					offset = {
						x = 1,
						y = -1
					},
					color = {
						mode = "fix", -- fix, class, health
						shadeMode = "hsvShade", -- rgbShade, hsvShade
						alpha = 0.9,
						fix = {r=0/255, g=0/255, b=0/255, a=255/255},
						rgb = {r=0, g=0, b=0},
						hsv = {h=0, s=0, v=0.6}
					}
				}
			},
			lengthLimit = 0.9, -- percent, value between 0 and 1
			color = {
				mode = "class", -- fix, class, health
				shadeMode = "hsvShade", -- rgbShade, hsvShade
				alpha = 1,
				fix = {r=255/255, g=255/255, b=255/255, a=200/255},
				rgb = {r=0, g=0, b=0},
				hsv = {h=0, s=0, v=0.8}
			}
		},
		healthText = {
			anchor = "CENTER",
			--show = true,
			offset = {
				x = 0,
				y = -10
			},
			mode = "remaining", --remaining, missing, percent
			display = "sH", -- sHsS, sHfS, fHsS, fHfS, sH, fH
			value = "healthAndShield", -- healthOnly, healthAndShield, healthPlusShield, includeShield
			font = {
				file = "Friz Quadrata TT",
				size = 12,
				outline = false,
				shadow = {
					offset = {
						x = 1,
						y = -1
					},
					color = {
						mode = "fix", -- fix, class, health
						shadeMode = "hsvShade", -- rgbShade, hsvShade
						alpha = 0.9,
						fix = {r=0/255, g=0/255, b=0/255, a=255/255},
						rgb = {r=0, g=0, b=0},
						hsv = {h=0, s=0, v=0.6}
					}
				}
			},
			color = {
				mode = "class", -- fix, class, health
				shadeMode = "hsvShade", -- rgbShade, hsvShade
				alpha = 1,
				fix = {r=255/255, g=255/255, b=255/255, a=200/255},
				rgb = {r=0, g=0, b=0},
				hsv = {h=0, s=0, v=0.8}
			}
		},
		statusText = {
			anchor = "CENTER",
			offset = {
				x = 0,
				y = -10
			},
			font = {
				file = "2002",
				size = 14,
				outline = false,
				shadow = {
					offset = {
						x = 1,
						y = -1
					},
					color = {
						mode = "fix", -- fix, class, health
						shadeMode = "hsvShade", -- rgbShade, hsvShade
						alpha = 0.9,
						fix = {r=0/255, g=0/255, b=0/255, a=0/255},
						rgb = {r=0, g=0, b=0},
						hsv = {h=0, s=0, v=0}
					}
				}
			},
			color = {
				mode = "class", -- fix, class, health
				shadeMode = "hsvShade", -- rgbShade, hsvShade
				alpha = 1,
				fix = {r=255/255, g=255/255, b=255/255, a=200/255},
				rgb = {r=0, g=0, b=0},
				hsv = {h=0, s=0, v=-1}
			}
		},
		threat = {
			file = "threat-7",
			color = {
				default = {
					use = false,
					alpha = {
						overnuking = 0.4,
						losing = 0.5,
						tanking = 0.7
					}
				},
				overnuking = {r=255/255, g=255/255, b=120/255, a=200/255},
				losing     = {r=255/255, g=150/255, b=0/255,   a=220/255},
				tanking    = {r=240/255, g=10/255,  b=10/255,  a=255/255}
			}
		},
		selection = {
			file = "select-4",
			color = {r=255/255, g=255/255, b=120/255, a=200/255},
			highlightColor = {r=220/255, g=220/255, b=220/255, a=50/255}
		}
		-- , ...
	}
}

--[[
Required method:

function UnitButtons:Initialize()
	...
	self.initDone = true
end

of which must set the UnitFrames.initDone variable to true when it's finished successfully.


Required method for config:

function UnitButtons:CreateEditor()
	CreateFrame
	...
	frame:addChild(xy)
	...
	frame:AddChildren(f1, f2, f3)
	...
	return frame
end

]]
